#======================================================
# A simple app that draws a pixelated ball that bounces
# around the LCD while blinking the onboard LED
#======================================================

from SBApp import SBApp
import time
import pyb
import time
import graphics
import color
import uasyncio as asyncio

name = "Bouncing Ball"
author = "SBI"
version = 1
update = 0
patch = 0

lcdWidth=320
lcdHeight=240
bgColor=color.WHITE
textColor=color.BLUE
dotColor=color.BLACK

class Main(SBApp):
	def __init__(self):
		super().__init__(name,author,version,update,patch)

	async def main(self):
		leds = [pyb.LED(i) for i in range(1,4)]

		n = 0
		x = y = 0
		dx = dy = 4
		graphics.paint(bgColor)                 
		graphics.print("Hello STEMBot 2!", 100, 100, textColor)
	
		while True:

			# update the dot's position
			x += dx
			y += dy

			# make the dot bounce of the edges of the screen
			if x <= 0 or x > 320-2: dx = -dx
			if y <= 0 or y > 240-2: dy = -dy

			graphics.pixel(x, y, dotColor)          # draw the dot
			graphics.pixel(x+1, y, dotColor)          # draw the dot
			graphics.pixel(x, y+1, dotColor)          # draw the dot
			graphics.pixel(x+1, y+1, dotColor)          # draw the dot
	 
			n = (n + 1) % 3
			leds[n].toggle()
			await asyncio.sleep_ms(50) # pause for 50ms
		
			graphics.pixel(x, y, bgColor)          # erase the dot
			graphics.pixel(x+1, y, bgColor)          # erase the dot
			graphics.pixel(x, y+1, bgColor)          # erase the dot
			graphics.pixel(x+1, y+1, bgColor)          # erase the dot
	 