import uasyncio as asyncio

class SBApp():

	def __init__(self, nameIn, author, versionNumberIn, updateNumberIn, patchNumberIn):
		self.setName(nameIn[:15])
		self.setAuthor(author[:15])
		self.setVersion(versionNumberIn)
		self.setUpdate(updateNumberIn)
		self.setPatch(patchNumberIn)
		super().__init__()


	def setAuthor(self, author):

		if (author == None):
			raise Exception("App author cannot be Null.")
		else:
			self.author = author


	def setName(self, nameIn):

		if (nameIn == None):
			raise Exception("App name cannot be Null.")
		else:
			self.name = nameIn

	def setPatch(self, patchNumberIn):

		if (not isinstance(patchNumberIn, int)):
			raise Exception("App patch must be an int.")
		elif (patchNumberIn < 0):
			self.patchNumber = 0;
		else:
			self.patchNumber = patchNumberIn

	def setUpdate(self, updateNumberIn):

		if (not isinstance(updateNumberIn, int)):
			raise Exception("App update must be an int.")
		elif (updateNumberIn < 0):
			self.updateNumber = 0
		else:
			self.updateNumber = updateNumberIn

	def setVersion(self, versionNumberIn):

		if (not isinstance(versionNumberIn, int)):
			raise Exception("App version must be an int.")
		elif (versionNumberIn < 0):
			self.versionNumber = 0
		else:
			self.versionNumber = versionNumberIn

	def __str__(self):
		return "'" + self.name + "' v" + repr(self.versionNumber) + "." + repr(self.updateNumber) + "." + repr(self.patchNumber)

	def main(self):
		raise NotImplementedError('subclasses must override main()!')

	def GPI_END(self, i):
		while(True):
			await asyncio.sleep_ms(100)
			