import sb
import graphics

class BatteryIcon():
	def __init__(self, x, y, bgcolor, fgcolor):    
		self.x = x
		self.bat_x=x+10
		self.y = y
		self.w = 35+10
		self.bat_w=35
		self.h=15
		self.bgcolor=bgcolor
		self.fgcolor=fgcolor
		self.nbars = 0

	def returnNBars(self):
		vbat = sb.getBatVoltage()
		nbars = 0
		if vbat >= 900:		#above 8.2V
			nbars = 6
		elif vbat >= 850:	#above 7.8V
			nbars = 5
		elif vbat >= 830:	#above 7.6V
			nbars = 4
		elif vbat >= 800:	#above 7.4V
			nbars = 3
		elif vbat >= 785:	#above 7.2V
			nbars = 2
		else:
			nbars = 1
		return nbars
		
	def paint(self):
		graphics.fill_rectangle(self.x,self.y,self.w,self.h,self.bgcolor)
		graphics.rectangle(self.bat_x,self.y,self.bat_w-2,self.h,self.fgcolor)
		graphics.fill_rectangle(self.bat_x+self.bat_w-2,self.y+4,2,self.h-8,self.fgcolor)

		self.nbars = self.returnNBars()
		xoff=2
		for i in range(self.nbars):
			graphics.fill_rectangle(self.bat_x+xoff,self.y+2,4,(self.h-4),self.fgcolor)
			xoff=xoff+5
	
	def update(self):
		chrg_stat = sb.getChargerStatus()& 0x20
		if(chrg_stat!=0):
			graphics.fill_rectangle(self.x,self.y+3,8,self.h-8,self.fgcolor)
			graphics.fill_rectangle(self.x+2,self.y,2,3,self.fgcolor)
			graphics.fill_rectangle(self.x+5,self.y,2,3,self.fgcolor)
			graphics.fill_rectangle(self.x+3,self.y+self.h-5,2,4,self.fgcolor)
		else:
			graphics.fill_rectangle(self.x,self.y,10,self.h,self.bgcolor)
		
		nbars = self.returnNBars()
		if(self.nbars!=nbars):
			self.nbars=nbars 
			graphics.fill_rectangle(self.bat_x+1,self.y+1,self.bat_w-4,self.h-2,self.bgcolor)
			xoff=2
			for i in range(self.nbars):
				graphics.fill_rectangle(self.bat_x+xoff,self.y+2,4,(self.h-4),self.fgcolor)
				xoff=xoff+5