import graphics
import color

class MenuItem():   
	def __init__(self, text, callback, arg=None):
		self.text=text
		self.callback=callback
		self.arg=arg
		
class Menu():
   
	def __init__(self,  x,y , w,h, textColor=color.WHITE, bgColor=color.RED,hlColor=color.RGB(138, 14, 14)):
		self.x=x
		self.y=y
		self.w=w
		self.h=h
		self.items=[]
		self.idx=0
		self.prevItems=None
		self.textColor=textColor
		self.bgColor=bgColor
		self.hlColor=hlColor
		
	def addMenuItem(self, text, callback, arg=None):
		item = MenuItem(text, callback, arg) 
		self.items.append(item)
	
	def paint(self):
		c=0
		print(str(self.x)+" "+str(self.y)+" "+str(self.w)+" "+str(self.h))
		graphics.fill_rectangle(self.x,self.y,self.w,self.h,self.bgColor)
		for i in self.items:
			if(c==self.idx):
				graphics.fill_rectangle(self.x,self.y+18*c,self.w,18,self.hlColor)
			graphics.print(i.text, self.x+2,self.y+18*c+4, self.textColor)
			c=c+1
	
	def paintDelta(self, prevIdx):
		graphics.fill_rectangle(self.x,self.y+18*self.idx,self.w,18,self.hlColor)
		graphics.print(self.items[self.idx].text, self.x+2,self.y+18*self.idx+4, self.textColor)
	
		graphics.fill_rectangle(self.x,self.y+18*prevIdx,self.w,18,self.bgColor)
		graphics.print(self.items[prevIdx].text, self.x+2,self.y+18*prevIdx+4, self.textColor)
	
	
	def doUp(self):
		prevIdx=self.idx
		self.idx=self.idx-1
		if(self.idx<0):
			self.idx=len(self.items)-1
		self.paintDelta(prevIdx)
		print("up: "+str(self.idx))
	
	def doDown(self):
		prevIdx=self.idx
		self.idx=self.idx+1
		if(self.idx>len(self.items)-1):
			self.idx=0
		self.paintDelta(prevIdx)
		print("down: "+str(self.idx))

	def doSelect(self):
		ret = self.items[self.idx].callback(self.items[self.idx].arg)
		print("sel: "+str(ret))
		if(ret):
			self.prevItems=self.items
			self.items=ret
			self.idx=0
			self.paint()
		
	def doBack(self):
		print("back: "+str(self.prevItems))
		if(self.prevItems is not None):
			self.items=self.prevItems
			self.prevItems=None
			self.idx=0
			self.paint()
	