import uasyncio as asyncio
import remote
import graphics
import color

async def main():
	rdata=remote.RemoteData()
	r=remote.Remote()
		
	textColor = color.RGB(0, 255, 65) 
	buttonColor = color.RGB(255, 255, 0) 
	bgColor = color.RGB(0, 0, 0) 

	lastButtonState = 0xff
	lastRLR,lastRUD,lastLLR,lastLUD=-1,-1,-1,-1
	buttonr = 3

	leftLabels=["L1","L2","L3","Up","Down","Left","Right","Start"]
	rightLabels=["R1","R2","R3","Tri","Cir","X","Sqr","Select"]

	i,xAxis,yAxis=0,10,25
	while i<8:
		graphics.print(leftLabels[i],xAxis,yAxis,textColor)
		graphics.fill_circle(55,yAxis, buttonr, bgColor)
		graphics.circle(55,yAxis,buttonr,textColor)
		i+=1
		yAxis+=10

	graphics.print("Lt Joy Up/Down", 70, 25, textColor)
	graphics.print("Lt Joy Rt/Lt", 70, 35, textColor)
	graphics.print("Rt Joy Up/Down", 70, 55, textColor)
	graphics.print("Rt Joy Rt/Left", 70, 65, textColor)

	i,xAxis,yAxis=0,graphics.lcdwidth-70,25
	while i<8:
		graphics.print(rightLabels[i],xAxis,yAxis,textColor)
		graphics.fill_circle(xAxis+60,yAxis, buttonr, bgColor)
		graphics.circle(xAxis+60,yAxis,buttonr,textColor)
		i+=1
		yAxis+=10

	def updateButton(prev, cur, mask, x, y):
		if(not (prev&mask) and  (cur&mask)):
			graphics.fill_circle(x,y, buttonr, buttonColor)
		if((prev&mask) and  not(cur&mask)):
			graphics.fill_circle(x,y, buttonr, bgColor)
			graphics.circle(x,y, buttonr, textColor)

	def updateField(prev, cur, x, y, w, h):
		if(prev!=cur):
			graphics.fill_rectangle(x,y,w,h,bgColor)
			graphics.print('%d' % (cur), x, y, buttonColor)	

	totalCount=0
	errorCount=0

	#updateField(lastLUD, 0, 200, 25, 40, 10)
	#updateField(lastLLR, 0, 200, 35, 40, 10)
	#updateField(lastRUD, 0, 200, 50, 40, 10)
	#updateField(lastRLR, 0, 200, 65, 40, 10)
		

	while(True):
		try:
			r.read(rdata,50)
			remoteFlags=[remote.L1_BIT,remote.L2_BIT,remote.L3_BIT,remote.DPAD_UP_BIT,\
					remote.DPAD_DN_BIT,remote.DPAD_LT_BIT,remote.DPAD_RT_BIT,\
					remote.STRT_BIT,remote.R1_BIT,remote.R2_BIT,remote.R3_BIT,\
					remote.TRI_BIT,remote.CIR_BIT,remote.X_BIT,remote.SQR_BIT,\
					remote.SLCT_BIT]

			i,xAxis,yAxis=0,55,25
			while i<16:
				updateButton(lastButtonState,rdata.buttons,remoteFlags[i],xAxis,yAxis)
				i+=1
				yAxis+=10
				if yAxis>95:
					xAxis,yAxis=graphics.lcdwidth-10,25

			updateField(lastLUD, rdata.ljoy_up_down, 200, 25, 40, 10)
			updateField(lastLLR, rdata.ljoy_left_right, 200, 35, 40, 10)
			updateField(lastRUD, rdata.rjoy_up_down, 200, 50, 40, 10)
			updateField(lastRLR, rdata.rjoy_left_right, 200, 65, 40, 10)
		
			lastButtonState = rdata.buttons
			v1=lastLUD = rdata.ljoy_up_down
			v2=lastLLR = rdata.ljoy_left_right
			v3=lastRUD = rdata.rjoy_up_down
			v4=lastRLR = rdata.rjoy_left_right

			graphics.fill_rectangle(96,125,50,30,bgColor)
			totalCount+=1
			graphics.print("Total: {}".format(totalCount),40,125,textColor)
			if ((v1!=0)or(v2!=0)or(v3!=0)or(v4!=0)):
				errorCount+=1	#used for idle testing of the controller
			graphics.print("Change: {}".format(errorCount),40,140,textColor)

		except Exception as e:
			print("exception: "+str(e))
		
		await asyncio.sleep_ms(5)
	